Imports System.Xml

Public Class Form1

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        Me.Panel1.Controls.Clear()
        Me.TabControl1.TabPages.Clear()
        Dim xmlfile As XmlDocument = New XmlDocument()
        xmlfile.Load("ListeMenu.xml")
        Dim elems As XmlNodeList = xmlfile.SelectNodes("/menu").Item(0).ChildNodes
        Dim mess As String = ""
        For i As Integer = 0 To elems.Count - 1
            AddElemMenu(elems(i).InnerText, elems(i).Attributes("tabpage").Value)
        Next

    End Sub

    Private Sub AddElemMenu(ByVal itemText As String, ByVal associatedTP As String)
        ' Cration du bouton pour le menu
        Dim b As Button = New Button()
        b.Size = New Size(100, 40)
        b.Location = New Point(10, 10)
        b.Dock = DockStyle.Top
        b.Text = associatedTP
        b.FlatStyle = FlatStyle.Popup
        b.Name = "btn" & itemText.Replace(" ", "")
        AddHandler b.Click, AddressOf BtnMenu_click
        ' Si le tabpage associ n'xiste pas, on le cre
        If Me.TabControl1.Controls(associatedTP) Is Nothing Then
            Dim tbp As TabPage = New TabPage
            tbp.Name = associatedTP
            tbp.Text = associatedTP
            Me.TabControl1.TabPages.Add(tbp)
        End If
        ' On ajoute le bouton au menu avec la gestion du placement
        If Panel1.Controls.Count = 0 Then
            Me.Panel1.Controls.Add(b)
        Else
            Dim controls() As Control = New Control(Panel1.Controls.Count) {}
            Me.Panel1.Controls.CopyTo(controls, 0)
            Array.Copy(controls, 0, controls, 1, controls.Length - 1)
            controls(0) = b
            Panel1.Controls.AddRange(controls)
        End If
    End Sub

    Private Sub BtnMenu_click(ByVal sender As Object, ByVal e As EventArgs)
        Dim tbpname As String = CType(sender, Control).Text.Replace("btn", "")
        Me.TabControl1.SelectTab(tbpname)
    End Sub
End Class
